/*
 * DosagePatterns.java
 *
 * Created on 18 May 2009, 14:38
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package dosagenumbers;
import java.util.*;

/**
 *
 * @author pcairns
 */
public class DosagePatterns {

    private final static String[] PATTERNS = {"ny", "z.yn", "ny.yn" };

    /** Creates a new instance of DosagePatterns */
    public DosagePatterns() {
    }
    
    public static String getPattern( int pIndex ){
        return PATTERNS[ pIndex ];
    }
    
    public static int numPatterns(){
        return PATTERNS.length;
    }
    
    public static String getRegEx( int pIndex ){
        String lAnswer = patternToRegex( PATTERNS[ pIndex ] );
        return lAnswer;
    }
    
    private static String patternToRegex( String pPattern ){
        StringBuffer lRegEx = new StringBuffer();
        int lPatternLength = pPattern.length();
        int j;
        String lThisChar;
        
        for( j = 0; j < lPatternLength; j++ ){
            lThisChar = pPattern.substring( j, j+1 );
            if( lThisChar.equals("n")){
                lRegEx.append( "[1-9]");
            } else if (lThisChar.equals( "z" )){
                lRegEx.append( "[0-9]" );
            } else if( lThisChar.equals( "y" )){
                lRegEx.append( "([0-9]*)" );
            } else if( lThisChar.equals( "." )){
                lRegEx.append( "." );
            } else{
                System.out.println("Unknown dosage pattern: " + pPattern );
            }
        }
        
        return lRegEx.toString();
    }
    
    public static String getLongForm( int pInteger, int pFraction ){
        StringBuffer lAnswer = new StringBuffer();
        int i;
        int f;
        
        if( pFraction == 0){
            lAnswer.append( "n" );
            for( i = 1; i < pInteger; i++ ){
                lAnswer.append( "z" );
            }
        }
        else if( pInteger == 1 ){
            lAnswer.append("z.");
            for( f = 0; f < pFraction - 1; f++ ){
                lAnswer.append( "z" );   
            }
            lAnswer.append("n");            
        }
        else{ 
            lAnswer.append( "n" );
            for( i = 1; i < pInteger; i++ ){
                lAnswer.append( "z" );
            }
            lAnswer.append( "." );
             for( f = 0; f < pFraction - 1; f++ ){
                lAnswer.append( "z" );   
            }
            lAnswer.append("n");                       
        }
        
        return lAnswer.toString();
    }
    
    public  static Vector generateDosagesFor( String pLongForm ){
        Vector lDosages = new Vector();
        int i;
        int lPatternLength = pLongForm.length();
        String lThisChar;
        String lAppendages;
        
        //Need to kick it off
        lDosages.add( "" );
        
        for( i = 0; i< lPatternLength; i++ ){
            lThisChar = pLongForm.substring( i, i+1 );
            if( lThisChar.equals("z")){
                lAppendages = "0123456789";
            }
            else if( lThisChar.equals("n")){
                lAppendages = "123456789";
            }
            else if( lThisChar.equals(".")){
                lAppendages = ".";
            }
            else{
                lAppendages = "";
            }
            lDosages = addAppendages( lDosages, lAppendages);
        }
        
        
        return lDosages;       
    }
    
    private static Vector addAppendages( Vector pDosages, String pAppendages ){
        Vector lNewDosages = new Vector();
        int i, j;
        int lNumPrefixes = pDosages.size();
        int lNumApps = pAppendages.length();
        String lThisPrefix;
        String lThisAppendage;
        String lSum;
        
        for( i = 0; i < lNumPrefixes; i++){
            lThisPrefix = (String) pDosages.elementAt( i );
            for( j = 0; j < lNumApps; j++ ){
                lThisAppendage = pAppendages.substring(j, j+1);
                lSum = lThisPrefix + lThisAppendage;
                lNewDosages.add( lSum ); 
            }
        }
        
        return lNewDosages;        
    }

}
