/*
 * DosageValidator.java
 *
 * Created on 18 May 2009, 14:25
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package dosagenumbers;
import java.util.*;
import java.util.regex.*;


/**
 *
 * @author pcairns
 */
public class DosageValidator {

    public final static String INVALID_PATTERN = "xxxx";
    public final static int UNMATCHED = -1;
    
    
    Vector fPatterns;
    
    /** Creates a new instance of DosageValidator */
    public DosageValidator() {
        fPatterns = new Vector();
        compilePatterns();
    }
    
    private void compilePatterns(){
        int i;
        int lNumPatterns = DosagePatterns.numPatterns();
        String lThisRE;
        Pattern lPattern;
        
        for( i = 0; i< lNumPatterns; i++ ){
            lThisRE = DosagePatterns.getRegEx( i );
            lPattern = Pattern.compile( lThisRE );
            fPatterns.add( lPattern );
        }//for i
    }
    
    public String getPatternByIndex( int pIndex ){
        String lAnswer;
        
        if( pIndex < 0 || pIndex > DosagePatterns.numPatterns() ){
            lAnswer = INVALID_PATTERN;
        }
        else{ 
            lAnswer = DosagePatterns.getPattern( pIndex );
        }
        
        return lAnswer;
    }
    
    public int matchDosage( String pDosage ){
        int i;
        int lNumPatterns = DosagePatterns.numPatterns();
        Pattern lThisPattern;
        boolean lMatched = false; 
        int lAnswer = UNMATCHED;
        
        for( i = 0; i < lNumPatterns && !lMatched; i++){
            lThisPattern = (Pattern) fPatterns.elementAt( i );
            lMatched = lThisPattern.matcher( pDosage ).matches();
            if( lMatched ) lAnswer = i;
        }
        
        return lAnswer;      
    }    
        
}
