/*
 * Main.java
 *
 * Created on 12 May 2009, 09:52
 *
 */

package dosagenumbers;

import java.util.Vector;

/**
 *
 * @author pcairns
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        int i,f;
        int lDosageCount;
        int lNumDosages;
        String lDosageForm;
        String lThisDosage;
        int lDosageLength;
        KeySequences lSeqs;
        Vector lDosages;
        ErrorSummary lSummary;
        int kcount, rcount, ecount;
        double[] k = { 0.5, 1, 2, 5, 10};
        double[] e = { 0.005, 0.01, 0.02, 0.05, 0.1};
        double[] r = {10};
        double lErrorP;
        double lErrorQ;
        
        
        int lIntegerSize = 2;
        int lFractionSize = 2;
        
		String lDir;
        String lFileStem = "Dosage";
        String lFileSuffix = ".csv";
        String lFileName;
        StringList lOutput = new StringList();
        StringBuffer lTotalSummary;
        String lFirstSep;

        if( args.length > 0 ){
            lDir = args[0];     
        }
        else{
            System.out.println("Please provide a directory name to put the results into: doseagenumbers.Main <directory>");
			return;
        }
           
        for( ecount = 0; ecount < e.length; ecount++ ){
            for( kcount = 0; kcount < k.length; kcount++ ){
                lErrorP = e[ecount]/(k[kcount] + 1);
                lErrorQ = k[kcount] * lErrorP;

                ErrorRates.setKeyPressErrorRate( lErrorP );
                ErrorRates.setTruncateErrorRate( lErrorQ );

                lFileName = lFileStem + "_e"+e[ecount] + "_k" + k[kcount] + lFileSuffix;

                lOutput = new StringList();
                
                lTotalSummary = new StringBuffer();
                for( rcount = 0; rcount < r.length; rcount++ ){
                    if( rcount== 0 ) lFirstSep = ""; else lFirstSep = ErrorSummary.SEP; 
                    lTotalSummary.append(lFirstSep + ErrorSummary.format() );                                          
                }
                lOutput.add( lTotalSummary.toString() );
                  
                for( i = 1; i <= lIntegerSize; i++){
                    for( f= 0; f <= lFractionSize; f++ ){
                        lDosageForm = DosagePatterns.getLongForm( i, f );
                        lDosageLength = lDosageForm.length();
                        //System.out.println( lDosageForm);

                        lSeqs = new KeySequences( lDosageLength );
                        lDosages = DosagePatterns.generateDosagesFor( lDosageForm );
                        lNumDosages = lDosages.size();
                        for(  lDosageCount = 0; lDosageCount < lNumDosages; lDosageCount++ ){
                            lThisDosage = (String) lDosages.elementAt( lDosageCount );
                            //System.out.println( lThisDosage );
                            lSeqs.setDosage( lThisDosage );
                            lTotalSummary = new StringBuffer();
                            for( rcount = 0; rcount < r.length; rcount++ ){
                                lSummary = lSeqs.summariseProbs( r[rcount] );
                                if( rcount== 0 ) lFirstSep = ""; else lFirstSep = ErrorSummary.SEP; 
                                lTotalSummary.append(lFirstSep + lSummary.asString() );                      
                            }//for rcount
                            lOutput.add( lTotalSummary.toString() ); 
                        }//for lDosageCount
                    }//for f
                }//for i
                
                lOutput.toFile(lDir, lFileName );
				
           }//for kcount
        }//for ecount
        
     }
    
}
