/*
 * PatternMatcher.java
 *
 * Created on 13 May 2009, 14:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package dosagenumbers;
import java.util.*;
import java.util.regex.*;

/**
 *
 * @author pcairns
 */
public class PatternMatcher {
    
    private final static String[] PATTERNS = {"dnnn", "n.nd", "dn.d" };
    public final static int INVALID_INDEX = -1;
    public final static String INVALID_PATTERN = "xxxx";
    public final static int UNMATCHED = -1;
    
    Vector fPatterns;
    
    /** Creates a new instance of PatternMatcher */
    public PatternMatcher() {
        fPatterns = new Vector();
        compilePatterns();
    }
    
    private void compilePatterns(){
        int i,j;
        StringBuffer lRegEx;
        String lThisPattern;
        int lPatternLength;
        String lThisChar;
        Pattern lPattern;
        
        for( i = 0; i < PATTERNS.length; i++){
            lThisPattern = PATTERNS[i];
            lRegEx = new StringBuffer();
            lPatternLength = lThisPattern.length();
            
            for( j = 0; j < lPatternLength; j++ ){
                lThisChar = lThisPattern.substring( j, j+1 );
                if( lThisChar.equals("d")){
                    lRegEx.append( "[1-9]");    
                }
                else if (lThisChar.equals( "n" )){
                    lRegEx.append( "[0-9]" );
                }
                else if( lThisChar.equals( "." )){
                    lRegEx.append( "." );
                }
                else{
                    System.out.println("Unknown dosage pattern: " + lThisPattern );
                }
            }
            lPattern = Pattern.compile( lRegEx.toString() );
            fPatterns.add( lPattern );
        }
    }
    
    public String getPatternByIndex( int pIndex ){
        String lAnswer;
        
        if( pIndex < 0 || pIndex > PATTERNS.length ){
            lAnswer = INVALID_PATTERN;
        }
        else{ 
            lAnswer = PATTERNS[ pIndex ];
        }
        
        return lAnswer;
    }
    
    public int matchDosage( String pDosage ){
        int i;
        Pattern lThisPattern;
        boolean lMatched = false; 
        int lAnswer = UNMATCHED;
        
        for( i = 0; i < PATTERNS.length && !lMatched; i++){
            lThisPattern = (Pattern) fPatterns.elementAt( i );
            lMatched = lThisPattern.matcher( pDosage ).matches();
            if( lMatched ) lAnswer = i;
        }
        
        return lAnswer;      
    }    
    
    public Vector generateDosages(){
        int i;
        int lNumPatterns = PATTERNS.length;
        Vector lAnswer = new Vector();
        Vector lTheseDosages;
        
        for( i = 0; i < lNumPatterns; i++){
            lTheseDosages = generateDosagesFor( i );
            lAnswer.addAll(lTheseDosages);            
        }
        
        return lAnswer;
    }
    
    public Vector generateDosagesFor( int pIndex ){
        String lPattern = getPatternByIndex( pIndex );
        Vector lDosages = new Vector();
        int i;
        int lPatternLength = lPattern.length();
        String lThisChar;
        String lAppendages;
        
        //Need to kick it off
        lDosages.add( "" );
        
        for( i = 0; i< lPatternLength; i++ ){
            lThisChar = lPattern.substring( i, i+1 );
            if( lThisChar.equals("n")){
                lAppendages = "0123456789";
            }
            else if( lThisChar.equals("d")){
                lAppendages = "123456789";
            }
            else if( lThisChar.equals(".")){
                lAppendages = ".";
            }
            else{
                lAppendages = "";
            }
            lDosages = addAppendages( lDosages, lAppendages);
        }
        
        
        return lDosages;       
    }
    
    private Vector addAppendages( Vector pDosages, String pAppendages ){
        Vector lNewDosages = new Vector();
        int i, j;
        int lNumPrefixes = pDosages.size();
        int lNumApps = pAppendages.length();
        String lThisPrefix;
        String lThisAppendage;
        String lSum;
        
        for( i = 0; i < lNumPrefixes; i++){
            lThisPrefix = (String) pDosages.elementAt( i );
            for( j = 0; j < lNumApps; j++ ){
                lThisAppendage = pAppendages.substring(j, j+1);
                lSum = lThisPrefix + lThisAppendage;
                lNewDosages.add( lSum ); 
            }
        }
        
        return lNewDosages;        
    }
}
